#include <iostream>

using namespace std;

int main()
{
    //int n;
    //cin >> n;

    int O, A, B, AB;
    cin >> O >> A >> B >> AB;



    //for(int i = 1; i <= n; i++)
    //{
    int kolkotreba;
    char krvnagrupa;
    int kolkoostalo;
    cin >> krvnagrupa >> kolkotreba;

    //O = 0
    //a = 4
    //b = 3
    //ab = 43

    if (krvnagrupa == 'O')
    {
        kolkoostalo = O - kolkotreba;
        if (kolkoostalo < 0)
        {
            cout << "nemoguce";
            return 0;
        }
        else
        {
            cout << "moguce" << endl;
            cout << kolkoostalo << " " << A << " " << B<< " " << AB;
            return 0;
        }
    }






    else if (krvnagrupa == 'A')
    {
        kolkoostalo = (A + O) - kolkotreba;
        if (kolkoostalo < 0)
        {
            cout << "nemoguce";
            return 0;
        }

        else
        {
            cout << "moguce" << endl;

            if (kolkoostalo % 2 == 0) cout << kolkoostalo/2 << " " << kolkoostalo/2 << " " << B << " " << AB << endl;
            else cout << (kolkoostalo + 1) / 2 << " " << (kolkoostalo - 1) / 2 << " " << B << " " << AB << endl;
            return 0;
        }
    }



    else if (krvnagrupa == 'B')
    {
        kolkoostalo = (B + O) - kolkotreba;
        if (kolkoostalo < 0)
        {
            cout << "nemoguce";
            return 0;
        }
        else
        {
            cout << "moguce" << endl;

            if (kolkoostalo % 2 == 0) cout << kolkoostalo/2 << " " << A << " " << kolkoostalo/2 << " " << AB << endl;
            else cout << (kolkoostalo + 1) / 2 << " " << A << " " << (kolkoostalo - 1) / 2 << " " << AB << endl;
            return 0;
        }
    }



    else if (krvnagrupa == 'AB') //nije bas savrseno ali radi posao
    {
        kolkoostalo = (AB + O + A + B) - kolkotreba;
        if (kolkoostalo < 0)
        {
            cout << "nemoguce";
            return 0;
        }
        else
        {
            cout << "moguce" << endl;

            if (kolkoostalo % 4 == 0) cout << kolkoostalo / 4 << " " << kolkoostalo / 4 << " " << kolkoostalo / 4 << " " << kolkoostalo / 4 << endl;
            else if (kolkoostalo % 4 == 1) cout << (kolkoostalo - 1) / 4 << " " << (kolkoostalo - 1) / 4 << " " << (kolkoostalo - 1) / 4 << " " << (kolkoostalo + 3) / 4 << endl;
            else if (kolkoostalo % 4 == 2) cout << (kolkoostalo - 2) / 4 << " " << (kolkoostalo - 2) / 4 << " " << (kolkoostalo - 2) / 4 << " " << (kolkoostalo + 2) / 4 << endl;
            else if (kolkoostalo % 4 == 3) cout << (kolkoostalo - 3) / 4 << " " << (kolkoostalo - 3) / 4 << " " << (kolkoostalo - 3) / 4 << " " << (kolkoostalo + 1) / 4 << endl;
            return 0;
        }
    } else return 0;
    //}
}